=== debian/changelog ===
nootka (0.8.60~beta-0ubuntu5) raring; urgency=low

  * Remove qtmultimedia5-dev since it is non-used and powerpc can't build

 -- Howard Chan <smartboyhw@gmail.com>  Fri, 05 Apr 2013 19:00:47 +0800

nootka (0.8.60~beta-0ubuntu4) raring; urgency=low

  [ Prasad Murthy ]
  * Fix qmaxqminarm.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 03 Apr 2013 17:20:59 +0100

nootka (0.8.60~beta-0ubuntu3) raring; urgency=low

  [ Prasad Murthy ]
  * Fix qmaxqminarm.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 03 Apr 2013 16:42:37 +0100

nootka (0.8.60~beta-0ubuntu2) raring; urgency=low

  [ Prasad Murthy ]
  * Add qmaxqminarm.patch to fix compile on ARM

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 01 Apr 2013 14:21:01 +0100

nootka (0.8.60~beta-0ubuntu1) raring; urgency=low

  * Initial packaging of version 0.8.60 beta. (LP: #1157859)

 -- Howard Chan <smartboyhw@gmail.com>  Fri, 22 Mar 2013 22:04:15 +0800
